#CONTROLCODES 1
#INCLUDE "STANDARD.DEF"
HSCALE = $9F2A
VSCALE = $9F2B

FIFOFULL = %10000000
BIT16.ON = %00100000
STEREO.ON = %00010000
VOLMASK = %11110000
VOLMAX = %11111111
DefaultVolume = 14
MaxVolume = 15
GOSUB SaveCursor.AndColor
GOSUB SAVE.SCREEN.MODE
PRINT "{ISO ON}"
REM BVLOAD "VGAROM.PF",8,1,$F000
GOSUB FIXCURSOR
COLOR 1,0
CLS
PRINT " TESTING FILE SYSTEM"
GOSUB TestFileSystem
BLOAD "PLAYER3.BIN",8,3,$A000


BLOAD "LOADFRAMES8BPPC.BIN",8,2,$700

STARTAGAIN:
IF BASENAME$<>"" THEN SKIPGETNAME
PRINT:PRINT 
BASE = 3
BASENAME$(3)="FROSTY"

SKIPGETNAME:
  FRAMEFILE$=BASENAME$(BASE)+".A"
  AUDIOTRACK$=BASENAME$(BASE)+".ZCM"
  PLAYSTREAM = $A02D
  PLAYPCM = $A0B5

IF IsHostFS THEN SKIPFAST
  DOS "U0>B3"
  FASTMODE = -1
SKIPFAST:

TARGET = 0


GOSUB HIDEALL
COLOR 1,0:CLS


POKE HSCALE, 38
POKE VSCALE, 32

GOSUB SHOWTEXT


## Initially zero out the Sprite RAM
  POKE VERA.LOWADDR,0
  POKE VERA.MIDADDR,0
  POKE VERA.HIADDR, %00010000
  POKE R0L, $23
  POKE R0H, $9F
  POKE R1L, 0
  POKE R1H, $FF
  POKE A.REG, 0
  SYS MEM.FILL

## and The Palette Cache
  POKE R0L, $00
  POKE R0H, $04
  POKE R1L, 0
  POKE R1H, 2
  POKE A.REG, 0
  SYS MEM.FILL

GOSUB SetUpSprites
GOSUB SETDEFPAL

OPEN 4,8,4,FRAMEFILE$+",S,R"
DefaultVolume = 14

F$=AUDIOTRACK$
GOSUB GetZCMHeader

PLAY.BadApple:
   FillLoopCount = 6
   IF IsHostFS THEN FillLoopCount = 12
   POKE A.REG, FillLoopCount
   POKE X.REG, 6
   VERA.RATE = VERA.RATE - 1
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG
   BANK 3
   POKE R15L, 1
   SYS PLAYSTREAM
   SYS CLRCHN
   CLOSE 4
   CLOSE 6

   FOR X = 1 TO 70:SPRITE X,0:NEXT
   
   
   GOSUB PAL2BLACK

   BANK 0
   POKE $BF01, 5
   DOS "CD:.."
   LOAD "TRANSITION.PRG"

   END


LOADWAVE:
   GOSUB LoadWAVEHeader
   GOSUB ParseRIFFHeader
   RETURN

GetZCMHeader:
  IsWave = FALSE
  OPEN 6,8,6,F$+",S,R"
  FOR I = 1 TO 6:GET# 6, X$:NEXT I
  GET# 6, X$
  VERA.CFG = ASC(X$)
  GET# 6, X$
  VERA.RATE = ASC(X$)
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)
  PCMBits = 8
  IF (VERA.CFG AND BIT16.ON) = BIT16.ON THEN PCMBits=16:BytesPerSecond = BytesPerSecond*2
  IsStereo = ((VERA.CFG AND STEREO.ON) = STEREO.ON)
  VERA.CFG = ((VERA.CFG AND %11110000) OR DefaultVolume)
  IF IsStereo THEN BytesPerSecond = BytesPerSecond * 2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

ParseRIFFHeader:
  IsWave = (LEFT$(RIFFHDR$,4) = "RIFF") AND (MID$(RIFFHDR$,9,4)="WAVE")
  PCMBits = ASC(MID$(RIFFHDR$,35,1))
  TMP1 = ASC(MID$(RIFFHDR$,21,1))
  TMP2 = ASC(MID$(RIFFHDR$,22,1))
  NumChannels = ASC(MID$(RIFFHDR$,23,1))
  TMP4 = (TMP1) + (256*TMP2)
  IsPCM = (TMP4=1)
  TMP1 = ASC(MID$(RIFFHDR$,25,1))
  TMP2 = ASC(MID$(RIFFHDR$,26,1)) * 256
  TMP3 = ASC(MID$(RIFFHDR$,27,1)) * 65536
  SampleRate = TMP1+TMP2+TMP3
  VERA.RATE = FN ROUND((SampleRate / 48828.15) * 128)
  IsStereo = (NumChannels=2)
  IsSupported = (IsWave AND (PCMBits=16)) AND IsPCM AND ((NumChannels > 0) AND (NumChannels < 3))
  VERA.CFG=0
  IF NOT IsSupported THEN RETURN
  VERA.CFG = (VERA.CFG OR BIT16.ON)
  IF IsStereo THEN VERA.CFG = (VERA.CFG OR STEREO.ON)
  VERA.CFG = VERA.CFG OR DefaultVolume
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)*2
  IF IsStereo THEN BytesPerSecond = BytesPerSecond*2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

LoadWAVEHeader:
   RIFFHDR$ = RPT$(44,44)
   OPEN 6,8,6,F$+",S,R"
     POKE X.REG, 6
     SYS CHKIN
     POKE A.REG, 44
## GET A POINTER TO THE WAVEHDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(RIFFHDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     RETURN

SetupSprites:
   SPR.ADDON = 24
   VADDR.ADDON = $6000
   X1 = 0:Y1 = 0:VADDR=0
   FOR SPR = 1 TO 24
     SPRMEM SPR,0,VADDR,1
     SPRMEM SPR+SPR.ADDON,0,VADDR+VADDR.ADDON,1
     VADDR = VADDR+1024
     SPRITE SPR,3,0,0,2,2
     SPRITE SPR+SPR.ADDON,0,0,0,2,2
     MOVSPR SPR, X1,Y1
     MOVSPR SPR+SPR.ADDON, X1,Y1
     X1=X1+32:IF X1>=192 THEN X1=0:Y1=Y1+32
   NEXT
RETURN



DRAWFRAME:
  FOR JJ=1 TO 6:FRAME X1,Y1,X2,Y2,CC:X1=X1+1:X2=X2-1:Y1=Y1+1:Y2=Y2-1:CC=CC-CD:NEXT JJ
RETURN

TestFileSystem:
 F$="TESTFILE":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:TESTFILE,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"TESTFILE,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 63
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN




#INCLUDE "STANDARD.BI"

SETDEFPAL:
      F$="DPAL.BIN":GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      POKE $9F20, 0
      POKE $9F21, $FA
      POKE $9F22, %00010001
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = 1 TO 256:READ R:READ GB:POKE VERA.DATA0,GB:POKE VERA.DATA0,R:NEXT
      RETURN

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B





